import sys

# define the sorted() function for older python
if sys.version_info < (2,4):
    def __sorted__(iterable, cmp=None, key=None, reverse=False):
        "return a sorted copy of its input"
        seq = list(iterable)
        if reverse:
            seq.reverse()        # preserve stability
        if key is not None:
            seq = [(key(elem), i, elem) for i, elem in enumerate(seq)]
        seq.sort(cmp)
        if key is not None:
            seq = [elem for (key, i, elem) in seq]
        if reverse:
            seq.reverse()
        return seq
    __builtins__["sorted"] = __sorted__

