#
# Copyright 2006, 2007 Red Hat, Inc.
#
# This copyrighted material is made available to anyone wishing to use, modify,
# copy, or redistribute it subject to the terms and conditions of the GNU
# General Public License v.2.  This program is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY expressed or implied, including the
# implied warranties of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  Any Red Hat
# trademarks that are incorporated in the source code or documentation are not
# subject to the GNU General Public License and may only be used or replicated
# with the express permission of Red Hat, Inc.
#

from snake.translate import _,N_

# Taken directly from anaconda/textw/constants_text.py
# FIXME: do we really need this?
class Translator:
    """A simple class to facilitate on-the-fly translation for newt buttons"""
    def __init__(self, button, check):
        self.button = button
        self.check = check

    def __getitem__(self, which):
        if which == 0:
            return _(self.button)
        elif which == 1:
            return self.check
        raise IndexError

    def __len__(self):
        return 2

TEXT_OK_STR = N_("OK")
TEXT_OK_CHECK  = 0
TEXT_OK_BUTTON = Translator(TEXT_OK_STR, TEXT_OK_CHECK)

TEXT_CANCEL_STR = N_("Cancel")
TEXT_CANCEL_CHECK  = 1
TEXT_CANCEL_BUTTON = Translator(TEXT_CANCEL_STR, TEXT_CANCEL_CHECK)

TEXT_BACK_STR = N_("Back")
TEXT_BACK_CHECK = 2
TEXT_BACK_BUTTON = Translator(TEXT_BACK_STR, TEXT_BACK_CHECK)

TEXT_YES_STR = N_("Yes")
TEXT_YES_CHECK = 3
TEXT_YES_BUTTON = Translator(TEXT_YES_STR, TEXT_YES_CHECK)

TEXT_NO_STR = N_("No")
TEXT_NO_CHECK = 4
TEXT_NO_BUTTON = Translator(TEXT_NO_STR, TEXT_NO_CHECK)

TEXT_EXIT_STR = N_("Exit")
TEXT_EXIT_CHECK = 5
TEXT_EXIT_BUTTON = Translator(TEXT_EXIT_STR, TEXT_EXIT_CHECK)

TEXT_EDIT_STR = N_("Edit")
TEXT_EDIT_CHECK = 6
TEXT_EDIT_BUTTON = Translator(TEXT_EDIT_STR, TEXT_EDIT_CHECK)

TEXT_F12_CHECK = "F12"

exceptionText = _("An unhandled exception has occurred.  This "
                  "is most likely a bug.  Please save a copy of "
                  "the detailed exception and file a bug report "
                  "at https://fedorahosted.org/snake")

# snake/client.py check_tree return values
CHECK_TREE_SUCCESS = 0
CHECK_TREE_GONE = 1
CHECK_TREE_BROKEN = 2
CHECK_TREE_NOIMAGES = 3

# Tree boot image paths ... .treeinfo file should tell us ... but these
IMAGES_X86 = {'initrd': 'images/pxeboot/initrd.img',
              'kernel': 'images/pxeboot/vmlinuz',
              'diskboot.img': 'images/diskboot.img',
              'boot.iso': 'images/boot.iso'}

IMAGES_XEN = {'initrd': 'images/xen/initrd.img',
              'kernel': 'images/xen/vmlinuz'}

IMAGES_IA64 = {'initrd': 'images/pxeboot/initrd.img',
               'kernel': 'images/pxeboot/vmlinuz',
               'boot.img': 'images/boot.img',
               'boot.iso': 'images/boot.iso'}

IMAGES_PPC32 = {'initrd': 'ppc/ppc32/ramdisk.image.gz',
                'kernel': 'ppc/ppc32/vmlinuz',
                'zimage': 'images/netboot/ppc32.img'}

IMAGES_PPC64 = {'initrd': ['ppc/ppc64/ramdisk.image.gz',
                           'ppc/chrp/ramdisk.image.gz'],
                'kernel': ['ppc/ppc64/vmlinuz',
                           'ppc/chrp/vmlinuz',
                           'ppc/chrp/vmlinux'],
                'zimage': ['images/netboot/ppc64.img',
                           'images/pseries/netboot.img',
                           'images/netboot.img']}

IMAGES_S390 = {'initrd': 'images/initrd.img',
               'kernel': 'images/kernel.img',
               'generic.prm': 'images/generic.prm',}

