#
# Copyright 2006, 2007 Red Hat, Inc.
#
# This copyrighted material is made available to anyone wishing to use, modify,
# copy, or redistribute it subject to the terms and conditions of the GNU
# General Public License v.2.  This program is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY expressed or implied, including the
# implied warranties of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  Any Red Hat
# trademarks that are incorporated in the source code or documentation are not
# subject to the GNU General Public License and may only be used or replicated
# with the express permission of Red Hat, Inc. 
#

try:
    import dbus
except ImportError:
    pass
else:
    if getattr(dbus, 'version', (0,0,0) >= (0,40,0)):
        new_api = True
    else:
        new_api = False

def get_interface(bus, service, object, interface):
    iface = None
    if new_api: # newer api: get_object(), dbus.Interface()
        proxy = bus.get_object(service, object)
        iface = dbus.Interface(proxy, interface)
    else:       # deprecated api: get_service(), get_object()
        svc = bus.get_service(service)
        iface = svc.get_object(object, interface)
    return iface
