#
# Copyright 2006, 2007 Red Hat, Inc.
#
# This copyrighted material is made available to anyone wishing to use, modify,
# copy, or redistribute it subject to the terms and conditions of the GNU
# General Public License v.2.  This program is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY expressed or implied, including the
# implied warranties of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  Any Red Hat
# trademarks that are incorporated in the source code or documentation are not
# subject to the GNU General Public License and may only be used or replicated
# with the express permission of Red Hat, Inc. 
#

import os, httplib

def create_tar(filelist):
    fl=""
    for i in filelist:
        if not i[0] == '/':
            print "Path %s is not absolute, skipping." % i
            continue
        if os.path.exists(i):
            fl = fl + " %s" % i[1:]
        else:
            print "Path %s does not exist, skipping." % i
    if not fl: return False
    try:
        data = os.popen('tar -cp -C / -f - %s' % fl).read()
    except:
        return False
    else:
        return data

def save(server, path, filelist, machineid):
    data = create_tar(filelist)
    if not data: return
    http = httplib.HTTPConnection(server.replace('http://',''))
    headers = {'Content-type':'application/octet-stream', \
               'Content-Length':str(len(data)), 'User-Agent':'snake-client',\
               'X-SNAKE-MachineID':machineid}
    http.request('PUT', path, data, headers)
    response = http.getresponse()
    if response.status in (301, 302):
        print "Resource had moved to %s" % response.headers['Location']
    elif not response.status in (200, 201, 204):
        print "Remote host returned: %s %s" % (response.status, response.reason)
    response.close()
    return

def restore(server, path, machineid):
    http = httplib.HTTPConnection(server.replace('http://',''))
    http.putrequest('GET', "/files/%s/files.tar" % machineid)
    http.putheader('Accept','*/*')
    http.endheaders()
    response = http.getresponse()
    data = response.read()
    if response.status == 200:
        os.popen('tar -xp -C / -f -', 'w').write(data)
    else:
        print "Remote host returned: %s %s" % (response.status, response.reason)
    response.close()
    return
